/*
 * Nombre del Proyecto:
     DianaDecimavilla.c
 * Nombre del Autor:
     Diana Decimavilla (2012)
 * Description:
     Modulo AC-DC y Juego
 * Test configuration:
     MCU:             PIC16F887
     Oscillator:      HS, 08.0000 MHz
     SW:              mikroC PRO for PIC

 * NOTES:

*/

unsigned short mask(unsigned short num);
unsigned long int temp_res;
unsigned int Var1;
unsigned int unidad,decena;

void main() {
  ANSEL  = 0x01;              // Configure AN2 pin as analog
  ANSELH = 0;                 // Configure other AN pins as digital I/O
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;

  TRISA  = 0xFF;              // PORTA is input
  TRISB  = 0;                 // PORTC is output
  TRISC  = 0;                 // PORTC is output
  TRISD = 0;
  PORTC=0;
  PORTD=0;

  do{
       PORTB=0;
       PORTC=0x5E;// d
       PORTD=0x5E; //d
     }while(RA1_bit=='0' && RA2_bit=='0');
  if(RA1_bit=='1'){
            do {
               temp_res = ADC_Read(0);   // Get 10-bit results of AD conversion
               Var1=(temp_res*100/1024);
               decena=Var1/10;
               unidad=Var1%10;
               PORTB=Var1;
               PORTC=mask(unidad);
               PORTD=mask(decena);

               } while(1);//
     }
     Var1=0;
   if(RA2_bit=='1'){
          PORTC=0x3F;
          PORTD=0x3F;
          delay_ms(1000);
          PORTB=0x76;
          delay_ms(3000);
          PORTB=0;
          do{
              RB0_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
            if(RA3_bit=='1'){
                           Var1++;
              }

            delay_ms(1000);
            PORTB=0;
           do{
              RB1_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
           if(RA4_bit=='1'){
                           Var1++;
              }

            delay_ms(1000);
            PORTB=0;
           do{
              RB2_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
           if(RA4_bit=='1'){
                           Var1++;
              }

            delay_ms(1000);
            PORTB=0;
           do{
              RB3_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
           if(RA3_bit=='1'){
                           Var1++;
              }

            delay_ms(1000);
            PORTB=0;
           do{
              RB4_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
           if(RA4_bit=='1'){
                           Var1++;
              }

           delay_ms(1000);
           PORTB=0;
           do{
              RB5_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
           if(RA4_bit=='1'){
                           Var1++;
              }

           delay_ms(1000);
           PORTB=0;
           do{
              RB6_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
           if(RA4_bit=='1'){
                           Var1++;
              }

           delay_ms(1000);
           PORTB=0;
           do{
              RB7_bit=1;
           }while(RA3_bit=='0'&&RA4_bit=='0' );
           if(RA3_bit=='1'){
                           Var1++;
              }
            PORTB=Var1;
            delay_ms(3000);
           if(Var1==8){
                PORTB=0;
                PORTC=0x1F;
                PORTD=0x3D;
                delay_ms(2000);

                Var1=0;
                PORTC=0x3F;
                PORTD=0x3F;
                delay_ms(1000);
                PORTB=0xCA;
                delay_ms(2000);
                PORTB=0;
                do{
                   RB0_bit=1;
                   }while(RA3_bit=='0'&&RA4_bit=='0' );
                   if(RA3_bit=='1'){
                           Var1++;
                   }

                   delay_ms(1000);
                   PORTB=0;
                   do{
                      RB1_bit=1;
                      }while(RA3_bit=='0'&&RA4_bit=='0' );
                      if(RA4_bit=='1'){
                           Var1++;
                      }

                      delay_ms(1000);
                      PORTB=0;
                      do{
                         RB2_bit=1;
                      }while(RA3_bit=='0'&&RA4_bit=='0' );
                      if(RA3_bit=='1'){
                           Var1++;
                      }

                      delay_ms(1000);
                      PORTB=0;
                      do{
                         RB3_bit=1;
                      }while(RA3_bit=='0'&&RA4_bit=='0' );
                      if(RA4_bit=='1'){
                           Var1++;
                      }

                      delay_ms(1000);
                      PORTB=0;
                      do{
                      RB4_bit=1;
                      }while(RA3_bit=='0'&&RA4_bit=='0' );
                      if(RA3_bit=='1'){
                           Var1++;
                      }

                      delay_ms(1000);
                      PORTB=0;
                      do{
                         RB5_bit=1;
                      }while(RA3_bit=='0'&&RA4_bit=='0' );
                      if(RA3_bit=='1'){
                           Var1++;
                      }

                      delay_ms(1000);
                      PORTB=0;
                      do{
                      RB6_bit=1;
                      }while(RA3_bit=='0'&&RA4_bit=='0' );
                      if(RA4_bit=='1'){
                           Var1++;
                      }

                      delay_ms(1000);
                      PORTB=0;
                       do{
                          RB7_bit=1;
                       }while(RA3_bit=='0'&&RA4_bit=='0' );
                       if(RA3_bit=='1'){
                           Var1++;
                       }
                       PORTB=Var1;
                       delay_ms(1000);
                       if(Var1==8){
                                PORTB=0;
                                PORTC=0x1F;
                                PORTD=0x3D;
                                delay_ms(3000);

                                PORTC=0x3F;
                                PORTD=0x3F;
                                delay_ms(1000);
                                PORTB=0x65;
                                delay_ms(1000);
                                PORTB=0;
                                do{
                                   RB0_bit=1;
                                }while(RA3_bit=='0'&&RA4_bit=='0' );
                                if(RA4_bit=='1'){
                                      Var1++;
                                }

                                delay_ms(1000);
                                PORTB=0;
                                do{
                                   RB1_bit=1;
                                }while(RA3_bit=='0'&&RA4_bit=='0' );
                                if(RA3_bit=='1'){
                                     Var1++;
                                }

                                delay_ms(1000);
                                PORTB=0;
                                do{
                                   RB2_bit=1;
                                }while(RA3_bit=='0'&&RA4_bit=='0' );
                                if(RA4_bit=='1'){
                                      Var1++;
                                }

                                delay_ms(1000);
                                PORTB=0;
                                do{
                                   RB3_bit=1;
                                }while(RA3_bit=='0'&&RA4_bit=='0' );
                                if(RA3_bit=='1'){
                                      Var1++;
                                }

                                delay_ms(1000);
                                PORTB=0;
                                do{
                                   RB4_bit=1;
                                }while(RA3_bit=='0'&&RA4_bit=='0' );
                                if(RA3_bit=='1'){
                                      Var1++;
                                }

                                delay_ms(1000);
                                PORTB=0;
                                do{
                                   RB5_bit=1;
                                }while(RA3_bit=='0'&&RA4_bit=='0' );
                                if(RA4_bit=='1'){
                                       Var1++;
                                }

                                delay_ms(1000);
                                PORTB=0;
                                do{
                                RB6_bit=1;
                                }while(RA3_bit=='0'&&RA4_bit=='0' );
                                if(RA4_bit=='1'){
                                     Var1++;
                                }

                                delay_ms(1000);
                                PORTB=0;
                                do{
                                   RB7_bit=1;
                                 }while(RA3_bit=='0'&&RA4_bit=='0' );
                                 if(RA3_bit=='1'){
                                        Var1++;
                                 }
                                 PORTB=Var1;
                                 delay_ms(3000);
                                 if(Var1==8){
                                 PORTB=0;
                                 PORTC=0x1F;
                                 PORTD=0x3D;
                                 }
                                 else{
                                 PORTB=0;
                                 PORTC=0x1F;
                                 PORTD=0x73;
                                 }




                       }
                       else{
                            PORTB=0;
                            PORTC=0x1F;
                            PORTD=0x73;
                            }




           }
           else{
                PORTB=0;
                PORTC=0x1F;
                PORTD=0x73;
           }

   }
}

unsigned short mask(unsigned short num) {
switch (num) {
case 0 : return 0x3F;
case 1 : return 0x06;
case 2 : return 0x5B;
case 3 : return 0x4F;
case 4 : return 0x66;
case 5 : return 0x6D;
case 6 : return 0x7D;
case 7 : return 0x07;
case 8 : return 0x7F;
case 9 : return 0x6F;
}
}